#pragma once

#include <stdbool.h>

enum ap_account_type
{
	apacct_Person = 1,
};

struct ap_crypto_key
{
	char* id;
	char* owner;
	char* pem;
};

struct ap_account
{
	char* id;
	int type;
	char* url;

	char* name;
	char* preferredUsername;
	char* inbox;
	char* shared_inbox;
	char* outbox;

	char* featured;
	char* followers;
	char* following;

	char* avatar;
	char* banner;

	char* summary;

	bool discoverable;

	struct ap_crypto_key public_key;
};

struct ap_account* ap_account_from_file( const char* filename );
void ap_account_free( struct ap_account* acc );

void ap_account_debug_dump( struct ap_account* acc );

